 lorom

org $008D73
 jmp CONTROL_HACK	;hacks controls to use L/R for shoot

org $00C05E
 lda #$71		;hacks BG2 in towns to 8x8 (from 0x71)
			;THIS IS OBSOLETE. I intended to write #$51 to permanently change BG2 to 8x8, but it glitched up the level-select screen,
			;so now it will load 16x16 tile size, and only switch to 8x8 when text is printed. I think this fixes it.

org $00BF00
CONTROL_HACK:	;original routine check $0468 (00 or 01, value 1 if currently holding the SPEED button (X/Y)
			;AND with $046A (FF). If result 1, shoot and set $046A to FE (= bit 0 set to 0) until released)
 lda $046D		;AXLR status
 EOR $FF		;invert pressed/not pressed
 AND $046B		;last pressed
 AND #$30		;check LR
 BEQ NoShoot
 JMP $8D7B		;shoot routine
NoShoot:
 JMP $8DCC
TileWidth:		;unused. I tried to reduce the font size to load tiles into each 8x8 tile in VRAM,
 LSR A		;but it crashed the game, so it can only load to 16x16 tiles. Fine, we just will only use the upper-left 8x8.
 LSR A
 LSR A
 JMP $9625
BG2SIZE_HACK:	;setting BG2 to 8x8 tile size when text is printed. It should revert back to the default of 16x16 after the next area
 sep #$20		;is loaded
WaitVB1:
 lda $4212		;wait for VBlank before changing PPU registers
 bmi WaitVB1
WaitVB2:
 lda $4212
 bpl WaitVB2
 lda #$51		;sets tile size of BGs. Replacing #$71 with #$51 switches BG2 from 16x16 to 8x8
 sta $2105
 rep #$20
 lda #$7C08		;set tile map address (to $F810). This will approximately center the text.
 sta $2116
 rtl
FIX_CLEAR_TILEMAP:
 lda #$0200		;tile to fill tilemap with
 ldx #$0200		;amount of data to fill with
FixClearTMLoop:
 sta $2118
 dex
 bne FixClearTMLoop
 sep #$20
WaitVB3:		;we need to wait for VBlank again. This routine came from an existing VRAM-writing loop.
 lda $4212		;But we were writing too much data, so it needs to be split into two steps.
 bmi WaitVB3
WaitVB4:
 lda $4212
 bpl WaitVB4
 rep #$20
 lda #$7E00
 sta $2116
 lda #$0200
 ldx #$0200
 rtl

;Font routine hack:

;Font routine - loads top 16x8 pixels of a 4bpp tile
;$01/965C A5 84       LDA $84    [$00:0084]   A:5403 X:C308 Y:2900 D:0000 DB:01 S:01E8 P:envmxdIzcHC:0020 VC:226 00 FL:06
;$84 = VRAM address
;$01/965E 8D 16 21    STA $2116  [$01:2116]   A:1800 X:C308 Y:2900 D:0000 DB:01 S:01E8 P:envmxdIzcHC:0052 VC:226 00 FL:06
;$01/9661 A2 20 00    LDX #$0020              A:1800 X:C308 Y:2900 D:0000 DB:01 S:01E8 P:envmxdIzcHC:0088 VC:226 00 FL:06
;$01/9664 B7 BA       LDA [$BA],y[$03:A900]   A:1800 X:0020 Y:2900 D:0000 DB:01 S:01E8 P:envmxdIzcHC:0112 VC:226 00 FL:06
;$01/9666 8D 18 21    STA $2118  [$01:2118]   A:0000 X:0020 Y:2900 D:0000 DB:01 S:01E8 P:envmxdIZcHC:0168 VC:226 00 FL:06
;ROM address + 2, 0x20 reps for 0x40 bytes
;$01/9669 C8          INY                     A:0000 X:0020 Y:2900 D:0000 DB:01 S:01E8 P:envmxdIZcHC:0204 VC:226 00 FL:06
;$01/966A C8          INY                     A:0000 X:0020 Y:2901 D:0000 DB:01 S:01E8 P:envmxdIzcHC:0218 VC:226 00 FL:06
;$01/966B CA          DEX                     A:0000 X:0020 Y:2902 D:0000 DB:01 S:01E8 P:envmxdIzcHC:0232 VC:226 00 FL:06
;$01/966C D0 F6       BNE $F6    [$9664]      A:0000 X:001F Y:2902 D:0000 DB:01 S:01E8 P:envmxdIzcHC:0246 VC:226 00 FL:06
;$01/9673 A8          TAY                     A:2B00 X:0000 Y:2940 D:0000 DB:01 S:01E8 P:envmxdIzcHC:1046 VC:229 00 FL:06
;$01/9674 A5 84       LDA $84    [$00:0084]   A:2B00 X:0000 Y:2B00 D:0000 DB:01 S:01E8 P:envmxdIzcHC:1060 VC:229 00 FL:06
;$01/9676 18          CLC                     A:1800 X:0000 Y:2B00 D:0000 DB:01 S:01E8 P:envmxdIzcHC:1092 VC:229 00 FL:06
;$01/9677 69 00 01    ADC #$0100              A:1800 X:0000 Y:2B00 D:0000 DB:01 S:01E8 P:envmxdIzcHC:1106 VC:229 00 FL:06
;$01/967A 8D 16 21    STA $2116  [$01:2116]   A:1900 X:0000 Y:2B00 D:0000 DB:01 S:01E8 P:envmxdIzcHC:1130 VC:229 00 FL:06
;increment VRAM address to the bottom line of 16x8 tiles
;$01/967D A2 20 00    LDX #$0020              A:1900 X:0000 Y:2B00 D:0000 DB:01 S:01E8 P:envmxdIzcHC:1166 VC:229 00 FL:06
;$01/9680 B7 BA       LDA [$BA],y[$03:AB00]   A:1900 X:0020 Y:2B00 D:0000 DB:01 S:01E8 P:envmxdIzcHC:1190 VC:229 00 FL:06
;$01/9682 8D 18 21    STA $2118  [$01:2118]   A:0000 X:0020 Y:2B00 D:0000 DB:01 S:01E8 P:envmxdIZcHC:1246 VC:229 00 FL:06
;$01/9685 C8          INY                     A:0000 X:0020 Y:2B00 D:0000 DB:01 S:01E8 P:envmxdIZcHC:1282 VC:229 00 FL:06
;$01/9686 C8          INY                     A:0000 X:0020 Y:2B01 D:0000 DB:01 S:01E8 P:envmxdIzcHC:1296 VC:229 00 FL:06
;$01/9687 CA          DEX                     A:0000 X:0020 Y:2B02 D:0000 DB:01 S:01E8 P:envmxdIzcHC:1310 VC:229 00 FL:06
;$01/9688 D0 F6       BNE $F6    [$9680]      A:0000 X:001F Y:2B02 D:0000 DB:01 S:01E8 P:envmxdIzcHC:1324 VC:229 00 FL:06
;$01/968A 60          RTS                     A:0000 X:0000 Y:2B40 D:0000 DB:01 S:01E8 P:envmxdIZcHC:0704 VC:233 00 FL:06


;org $019622
; lsr a
; lsr a
; lsr a
; I tried to add an extra lsr to make the game only load a font tile each 8x8 tile.
; crashed the game

;Many values below are actually the game's original values.
;but I'm noting them as possibly interesting

org $019661
 ldx #$0020		;reduce size to 8 pixels wide

org $01966E		;leave it at 1 8x8 tile
 tya

org $0196D5
 jsl BG2SIZE_HACK
 nop
 nop
; lda #$7C08		;position in tilemap (default 7C00, edge of screen)

org $0196B1		;initial position to clear tilemap
 lda #$7C00

org $0196DE
 ldx #$0008		;number of tiles in the top 8x8 line

org $0196E5
 inc a		;+2 per tile in the top 8x8 to +1 (NOP it to change it to 1 tile: 80, 81, 82, 83... etc. written to the tilemap)
			;but because I had issues adjust the tile size. It had to move it back up to 2: writing 80, 82, 84, 86, etc. to the tilemap

org $0196EA		;number of tiles down for the next part of the line
 adc #$0010

org $0196ED
 ldx #$0008		;number of tiles in the upper-right 8x8

org $0196F4
 inc a		;+2 per tile in the second 8x8 line to +1

org $0196F8
 lda #$7C28		;tilemap position of lower line

org $019701
 ldx #$0008		;number of tiles in the lower-left 8x8

org $019708
 inc a		;+2 per tile in the third 8x8 line to +1

org $01970D
 adc #$0010		;number of tiles down for the next part of the line

org $019710
 ldx #$0008		;number of tiles in the lower-right 8x8

org $019717
 inc a		;+2 per tile in the fourth 8x8 line to +1

org $0196C9
; lda #$0200		;properties for blank tiles at the end of the tilemap
; ldx #$0340
 jsl FIX_CLEAR_TILEMAP
 nop
 nop

org $0196B7
 lda #$0200		;tile to fill blank space
 ldx #$0200